// Code generated by go-swagger; DO NOT EDIT.

package roles

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// UserRoleEditHandlerFunc turns a function with the right signature into a user role edit handler
type UserRoleEditHandlerFunc func(UserRoleEditParams) middleware.Responder

// Handle executing the request and returning a response
func (fn UserRoleEditHandlerFunc) Handle(params UserRoleEditParams) middleware.Responder {
	return fn(params)
}

// UserRoleEditHandler interface for that can handle valid user role edit params
type UserRoleEditHandler interface {
	Handle(UserRoleEditParams) middleware.Responder
}

// NewUserRoleEdit creates a new http.Handler for the user role edit operation
func NewUserRoleEdit(ctx *middleware.Context, handler UserRoleEditHandler) *UserRoleEdit {
	return &UserRoleEdit{Context: ctx, Handler: handler}
}

/*UserRoleEdit swagger:route PUT /api/roles/{id} Roles userRoleEdit

Edit role

*/
type UserRoleEdit struct {
	Context *middleware.Context
	Handler UserRoleEditHandler
}

func (o *UserRoleEdit) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserRoleEditParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
